Salazar Slytherin's Locket CodeForces - 855E

Salazar Slytherin‘s Locket CodeForces - 855E

http://www.cnblogs.com/ftae/p/7590187.html

数位dp:

http://www.cnblogs.com/xz816111/p/4809913.html

http://blog.csdn.net/wust_zzwh/article/details/52100392

1.

 1 #include<cstdio>
 2 #include<cstring>
 3 typedef long long LL;
 4 LL q,b,l,r;
 5 LL ans[11][70][2049][2];
 6 LL w[70];//记录拆出来的i进制的各个数字
 7 //ans[i][j][state][k]:i进制,i进制下j长度,状态为state,k表示是否处于前导0
 8 //状态为0-b-1的数字出现奇数/偶数次
 9 LL dp(LL jz,LL pos,LL state,bool pre0,bool limit)//pre0表示当前位的前一位是不是0
10 {
11     if(pos<1)    return !state;//只有状态全0也就是所有数字出现偶数次才有1个答案,曾经忘记
12     if(!limit&&ans[jz][pos][state][pre0]!=-1)
13         return ans[jz][pos][state][pre0];
14     LL i,res=0,end=limit?w[pos]:(jz-1);//当前位上界,limit为0表示前面某一位已经取了不是最高值,那么后面的位可以取0-9//曾经把最大值错写成9
15     for(i=0;i<=end;i++)
16         if(i==0&&pre0)//如果当前位取0,且前面都是前导0,那么开头的0显然是不计入状态的
17             res+=dp(jz,pos-1,state,1,limit&&i==w[pos]);//曾经忘记写limit&&
18         else
19             res+=dp(jz,pos-1,state^(1<<i),0,limit&&i==w[pos]);
20     return limit?res:(ans[jz][pos][state][pre0]=res);
21 }
22 LL get(LL b,LL x)
23 {
24     LL g;
25     for(g=0;x>0;x/=b)    w[++g]=x%b;
26     return dp(b,g,0,1,1);//这一种的返回的直接就是1-x的总答案
27 }
28 int main()
29 {
30     memset(ans,-1,sizeof(ans));
31     scanf("%I64d",&q);
32     while(q--)
33     {
34         scanf("%I64d%I64d%I64d",&b,&l,&r);
35         printf("%I64d\n",get(b,r)-get(b,l-1));
36     }
37     return 0;
38 }

2.

 1 #include<cstdio>
 2 #include<cstring>
 3 typedef long long LL;
 4 LL q,b,l,r;
 5 LL ans[11][70][2049];
 6 LL w[70];
 7 //ans[i][j][state][k]:i进制,i进制下j长度,状态为state,k表示是否处于前导0
 8 //状态为0-b-1的数字出现奇数/偶数次
 9 LL dp(LL jz,LL pos,LL state,bool pre0,bool limit)//pre0表示当前位的前一位是不是0
10 {
11     if(pos<1)    return !state;//只有状态全0也就是所有数字出现偶数次才有1个答案
12     if(!limit&&!pre0&&ans[jz][pos][state]!=-1)
13         return ans[jz][pos][state];
14     LL i,res=0,start=pre0?1:0,end=limit?w[pos]:(jz-1);//当前位上界,limit为0表示前面某一位已经取了不是最高值,那么后面的位可以取0-9
15     for(i=start;i<=end;i++)
16         res+=dp(jz,pos-1,state^(1<<i),0,limit&&i==w[pos]);
17     if(!limit&&!pre0)
18         ans[jz][pos][state]=res;
19     return res;
20 }
21 LL get(LL b,LL x)
22 {
23     LL g,i,ret=0;
24     for(g=0;x>0;x/=b)    w[++g]=x%b;
25     for(i=g;i>=1;i--)    ret+=dp(b,i,0,1,i==g);//如果总位数不到g,那么显然所有数字都可以随便取
26     return ret;//这一种的dp返回的是1-x的数中i位的数满足条件的答案
27 }
28 int main()
29 {
30     memset(ans,-1,sizeof(ans));
31     scanf("%I64d",&q);
32     while(q--)
33     {
34         scanf("%I64d%I64d%I64d",&b,&l,&r);
35         printf("%I64d\n",get(b,r)-get(b,l-1));
36     }
37     return 0;
38 }

3.

Salazar Slytherin's Locket CodeForces - 855E

时间: 2024-10-11 06:33:36

Salazar Slytherin's Locket CodeForces - 855E的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ